package cn.bsl.bxbg.zhiban.adapter;

import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseExpandableListAdapter;
import android.widget.CheckBox;
import android.widget.ExpandableListView;
import android.widget.RadioButton;
import android.widget.TextView;

import java.util.ArrayList;
import java.util.List;

import cn.bsl.bxbg.zhiban.R;
import cn.bsl.bxbg.zhiban.bean.Group;
import cn.bsl.bxbg.zhiban.bean.SppUser;
import cn.bsl.bxbg.zhiban.listener.OnAddUserCountListener;


public class EListAdapter extends BaseExpandableListAdapter implements ExpandableListView.OnChildClickListener {

	private Context context;
	private ArrayList<Group> groups;
	private ArrayList<SppUser> childs;
	private OnAddUserCountListener listener;
	private Boolean flag;// converview监听radiobutton

	public EListAdapter(Context context, ArrayList<Group> groups) {
		this.context = context;
		this.groups = groups;
		childs = new ArrayList<SppUser>();
		listener = (OnAddUserCountListener) this.context;// 接口回调--选择人数--刷新视图
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.ExpandableListAdapter#getGroupCount()
	 */
	@Override
	public int getGroupCount() {
		return groups.size();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.ExpandableListAdapter#getChildrenCount(int)
	 */
	@Override
	public int getChildrenCount(int groupPosition) {
		return groups.get(groupPosition).getChildrenCount();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.ExpandableListAdapter#getGroup(int)
	 */
	@Override
	public Object getGroup(int groupPosition) {
		return groups.get(groupPosition);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.ExpandableListAdapter#getChild(int, int)
	 */
	@Override
	public Object getChild(int groupPosition, int childPosition) {
		return groups.get(groupPosition).getChildItem(childPosition);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.ExpandableListAdapter#getGroupId(int)
	 */
	@Override
	public long getGroupId(int groupPosition) {
		return groupPosition;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.ExpandableListAdapter#getChildId(int, int)
	 */
	@Override
	public long getChildId(int groupPosition, int childPosition) {
		return childPosition;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.ExpandableListAdapter#hasStableIds()
	 */
	@Override
	public boolean hasStableIds() {
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.ExpandableListAdapter#getGroupView(int, boolean,
	 * android.view.View, android.view.ViewGroup)
	 */
	@Override
	public View getGroupView(int groupPosition, boolean isExpanded, View convertView, ViewGroup parent) {
		Group group = (Group) getGroup(groupPosition);

		if (convertView == null) {
			convertView = LayoutInflater.from(context).inflate(R.layout.group_layout, null);
		}
		TextView tv = (TextView) convertView.findViewById(R.id.tvGroup);
		tv.setText(group.getName());

		// 重新產生 CheckBox 時，將存起來的 isChecked 狀態重新設定
		CheckBox checkBox = (CheckBox) convertView.findViewById(R.id.chbGroup);
		checkBox.setChecked(group.getChecked());
		// 點擊 CheckBox 時，將狀態存起來
		if (groupPosition == 0) {
			checkBox.setOnClickListener(new Group_CheckBox_Click2());
			if (group.getChecked()) {
				checkBox.setBackgroundResource(R.drawable.check_all);
			} else {
				checkBox.setBackgroundResource(R.drawable.check_no);
			}
		} else {
			checkBox.setOnClickListener(new Group_CheckBox_Click(groupPosition));
			// 檢查 User CheckBox 是否有全部勾選，以控制 Dept CheckBox
			int childrenCount = groups.get(groupPosition).getChildrenCount();
			boolean childrenAllIsChecked = true;
			Log.e("TAG", "SIZE=" + childrenCount);
			for (int i = 0; i < childrenCount; i++) {
				if (!groups.get(groupPosition).getChildItem(i).getChecked())
					childrenAllIsChecked = false;
			}
			if (childrenAllIsChecked) {
				groups.get(groupPosition).setChecked(childrenAllIsChecked);
				// checkBox.setChecked(childrenAllIsChecked);
				checkBox.setBackgroundResource(R.drawable.check_all);
			} else {
				groups.get(groupPosition).setChecked(group.getChecked());
				// checkBox.setChecked(group.getChecked());
				List<SppUser> ll = groups.get(groupPosition).getChildren();
				boolean flg = false;
				for (int i = 0; i < ll.size(); i++) {
					if (ll.get(i).getChecked()) {
						flg = true;
						break;
					}
				}
				if (flg)
					checkBox.setBackgroundResource(R.drawable.check_some);
				else
					checkBox.setBackgroundResource(R.drawable.check_no);

			}

		}

		return convertView;
	}

	/** 勾選 Group CheckBox 時，存 Group CheckBox 的狀態，以及改變 SppUser CheckBox 的狀態 */
	class Group_CheckBox_Click implements OnClickListener {
		private int groupPosition;

		Group_CheckBox_Click(int groupPosition) {
			this.groupPosition = groupPosition;
		}

		public void onClick(View v) {
			groups.get(groupPosition).toggle();
			childs.clear();
			// 將 Children 的 isChecked 全面設成跟 Group 一樣
			int childrenCount = groups.get(groupPosition).getChildrenCount();
			boolean groupIsChecked = groups.get(groupPosition).getChecked();
			for (int i = 0; i < childrenCount; i++) {
				groups.get(groupPosition).getChildItem(i).setChecked(groupIsChecked);
				// if (groupIsChecked) {
				// childs.add(groups.get(groupPosition).getChildItem(i));
				// } else {
				// childs.remove(groups.get(groupPosition).getChildItem(i));
				// }
			}
			boolean allChecked = true;
			for (int i = 1; i < groups.size(); i++) {
				if (!groups.get(i).getChecked())
					allChecked = false;
			}
			groups.get(0).setChecked(allChecked);
			// 注意，一定要通知 ExpandableListView 資料已經改變，ExpandableListView 會重新產生畫面
			notifyDataSetChanged();
			personsCount();
			listener.OnAddUserCountListener(childs.size());
		}
	}

	/** 勾選 Group CheckBox 時，存 Group CheckBox 的狀態，以及改變 SppUser CheckBox 的狀態 */
	class Group_CheckBox_Click2 implements OnClickListener {

		public void onClick(View v) {
			// childs.clear();
			// 將 Children 的 isChecked 全面設成跟 Group 一樣
			for (int i = 0; i < groups.size(); i++) {
				groups.get(i).toggle();
				Boolean group0IsCheck = groups.get(0).getChecked();
				groups.get(i).setChecked(group0IsCheck);
				int childrenCount = groups.get(i).getChildrenCount();
				boolean groupIsChecked = groups.get(i).getChecked();
				for (int j = 0; j < childrenCount; j++) {
					groups.get(i).getChildItem(j).setChecked(groupIsChecked);

					// if (groupIsChecked) {
					// childs.add(groups.get(i).getChildItem(j));
					// } else {
					// childs.remove(groups.get(i).getChildItem(j));
					// }
				}
			}
			personsCount();
			listener.OnAddUserCountListener(childs.size());
			// 注意，一定要通知 ExpandableListView 資料已經改變，ExpandableListView 會重新產生畫面
			notifyDataSetChanged();
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.ExpandableListAdapter#getChildView(int, int, boolean,
	 * android.view.View, android.view.ViewGroup)
	 */
	@Override
	public View getChildView(int groupPosition, int childPosition, boolean isLastChild, View convertView,
			ViewGroup parent) {
		SppUser child = groups.get(groupPosition).getChildItem(childPosition);

		if (convertView == null) {
			LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			convertView = inflater.inflate(R.layout.child_layout, null);
		}

		TextView tv = (TextView) convertView.findViewById(R.id.tvChild);
		tv.setText(child.getRolename());
		TextView name = (TextView) convertView.findViewById(R.id.tv_name);
		name.setText(child.getUsername());

		// 重新產生 CheckBox 時，將存起來的 isChecked 狀態重新設定
		final RadioButton checkBox = (RadioButton) convertView.findViewById(R.id.chbChild);
		checkBox.setChecked(child.getChecked());

		// 點擊 CheckBox 時，將狀態存起來
		checkBox.setOnClickListener(new Child_CheckBox_Click(groupPosition, childPosition));

		return convertView;
	}

	/** 勾選 SppUser CheckBox 時，存 SppUser CheckBox 的狀態 */
	class Child_CheckBox_Click implements OnClickListener {
		private int groupPosition;
		private int childPosition;

		Child_CheckBox_Click(int groupPosition, int childPosition) {
			this.groupPosition = groupPosition;
			this.childPosition = childPosition;
		}

		public void onClick(View v) {
			handleClick(childPosition, groupPosition);
			personsCount();
			listener.OnAddUserCountListener(EListAdapter.this.childs.size());
		}
	}

	public void handleClick(int childPosition, int groupPosition) {
		groups.get(groupPosition).getChildItem(childPosition).toggle();

		boolean flg = groups.get(groupPosition).getChildItem(childPosition).getChecked();
		// if (flg) {
		// childs.add(groups.get(groupPosition).getChildItem(childPosition));
		// } else {
		// childs.remove(groups.get(groupPosition).getChildItem(childPosition));
		// }

		// 檢查 SppUser CheckBox 是否有全部勾選，以控制 Group CheckBox
		int childrenCount = groups.get(groupPosition).getChildrenCount();
		boolean childrenAllIsChecked = true;
		for (int i = 0; i < childrenCount; i++) {
			if (!groups.get(groupPosition).getChildItem(i).getChecked())
				childrenAllIsChecked = false;
		}

		groups.get(groupPosition).setChecked(childrenAllIsChecked);

		boolean allChecked = true;
		for (int i = 1; i < groups.size(); i++) {
			if (!groups.get(i).getChecked())
				allChecked = false;
		}
		groups.get(0).setChecked(allChecked);

		// 注意，一定要通知 ExpandableListView 資料已經改變，ExpandableListView 會重新產生畫面
		notifyDataSetChanged();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.ExpandableListAdapter#isChildSelectable(int, int)
	 */
	@Override
	public boolean isChildSelectable(int groupPosition, int childPosition) {
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.widget.ExpandableListView.OnChildClickListener#onChildClick(
	 * android .widget.ExpandableListView, android.view.View, int, int, long)
	 */
	@Override
	public boolean onChildClick(ExpandableListView parent, View v, int groupPosition, int childPosition, long id) {
		handleClick(childPosition, groupPosition);
		return true;
	}

	public ArrayList<SppUser> getSelectedChild() {
		return childs;
	}



	public void personsCount() {
		childs.clear();
		int count = this.getGroupCount();
		for (int i = 1; i < count; i++) {
			Group group = groups.get(i);
			int childrenCount = group.getChildrenCount();
			for (int j = 0; j < childrenCount; j++) {
				if (group.getChecked()) {
					childs.add(group.getChildItem(j));
				} else if (group.getChildItem(j).getChecked()) {
					childs.add(group.getChildItem(j));
				}
			}
		}
	}

}
