package cn.bsl.bxbg.zhiban.view;

import android.os.Bundle;
import android.support.design.widget.TabLayout;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentStatePagerAdapter;
import android.support.v4.view.ViewPager;

import java.util.ArrayList;

import butterknife.BindView;
import butterknife.ButterKnife;
import cn.bsl.bxbg.zhiban.BaseActivity;
import cn.bsl.bxbg.zhiban.R;
import cn.bsl.bxbg.zhiban.fragment.AlreadyTakeOverFragment;
import cn.bsl.bxbg.zhiban.fragment.WaitShiftFragment;
import cn.bsl.bxbg.zhiban.fragment.WaitTakeOverFragment;

public class DutyTransferActivity extends BaseActivity {

    @BindView(R.id.jj_layout)
    TabLayout jjLayout;
    @BindView(R.id.jj_viewpager)
    ViewPager jjViewpager;
    private ArrayList<Fragment> waitMeFinishFragments = new ArrayList<>();
    private ViewPagerAdapter viewPagerAdapter;
    private String[] mTitles = new String[]{"待交班", "待接班","已交班"};
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_duty_transfer);
        ButterKnife.bind(this);
        initView();
    }

    private void initView() {
        viewPagerAdapter = new ViewPagerAdapter(getSupportFragmentManager());
        waitMeFinishFragments.add(new WaitShiftFragment());
        waitMeFinishFragments.add(new WaitTakeOverFragment());
        waitMeFinishFragments.add(new AlreadyTakeOverFragment());
        jjViewpager.setAdapter(viewPagerAdapter);
        jjLayout.setupWithViewPager(jjViewpager);
    }

    public class ViewPagerAdapter extends FragmentStatePagerAdapter {

        public ViewPagerAdapter(FragmentManager fm) {
            super(fm);
        }

        @Override
        public Fragment getItem(int position) {
            return waitMeFinishFragments.get(position);
        }

        @Override
        public int getCount() {
            return waitMeFinishFragments.size();
        }

        @Override
        public CharSequence getPageTitle(int position) {
            return mTitles[position];
        }
    }
}
