package cn.bsl.bxbg.zhiban.view;

import android.os.Bundle;
import android.support.annotation.Nullable;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import cn.bsl.bxbg.zhiban.BaseActivity;
import cn.bsl.bxbg.zhiban.R;
import cn.bsl.bxbg.zhiban.net.client.DutyPlanClient;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.schedulers.Schedulers;

/**
 * Created by Xinghx on 2018/5/20 0020.
 */

public class TakeOverDetailsActivity extends BaseActivity {
    @BindView(R.id.shift_zb_time)
    TextView shiftZbTime;
    @BindView(R.id.shift_zb_shift)
    TextView shiftZbShift;
    @BindView(R.id.shift_zb_person)
    TextView shiftZbPerson;
    @BindView(R.id.shift_zb_content)
    EditText shiftZbContent;
    @BindView(R.id.btn_ok)
    Button btnOk;
    @BindView(R.id.save)
    TextView save;

    private DutyPlanClient dutyPlanClient = new DutyPlanClient();
    private String trsid;
    private String dutyContent;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.shift_details_layout);
        ButterKnife.bind(this);

        initView();
    }

    private void initData() {

    }

    private void initView() {
        trsid = getIntent().getStringExtra("id");
        String status = getIntent().getStringExtra("status");
        String dutyTime = getIntent().getStringExtra("dutyTime");
        String dutyShift = getIntent().getStringExtra("dutyShift");
        dutyContent = getIntent().getStringExtra("dutyContent");
        shiftZbTime.setText(dutyTime);
        switch (dutyShift) {
            case "0":
                shiftZbShift.setText("早");
                break;
            case "1":
                shiftZbShift.setText("中");
                break;
            case "2":
                shiftZbShift.setText("晚");
                break;
        }

        shiftZbContent.setText(dutyContent + "");

        switch (status) {
            case "0":
                btnOk.setText("确认接班");
                shiftZbContent.setEnabled(false);
                shiftZbContent.setFocusable(false);
                shiftZbContent.setKeyListener(null);
                shiftZbContent.setHint("");
                break;
            case "1":
                save.setVisibility(View.VISIBLE);
                btnOk.setText("交班");
                break;
            case "2":
                btnOk.setVisibility(View.GONE);
                shiftZbContent.setEnabled(false);
                shiftZbContent.setFocusable(false);
                shiftZbContent.setKeyListener(null);
                shiftZbContent.setHint("");
                break;
        }
    }


    @OnClick({R.id.save, R.id.btn_ok})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.save:
                // 编辑值班记录
                dutyPlanClient.editShiftRecord(trsid,shiftZbContent.getText().toString())
                        .observeOn(AndroidSchedulers.mainThread())
                        .subscribeOn(Schedulers.io())
                        .subscribe(shiftBeen -> {
                            Toast.makeText(this, "修改成功", Toast.LENGTH_SHORT).show();
                            finish();
                        },Throwable::printStackTrace);
                break;
            case R.id.btn_ok:
                if (btnOk.getText().equals("确认接班")) {
                    dutyPlanClient.editShiftStatus(trsid,"2")
                            .subscribeOn(Schedulers.io())
                            .observeOn(AndroidSchedulers.mainThread())
                            .subscribe(shiftBean -> {
                                Toast.makeText(this, "接班成功", Toast.LENGTH_SHORT).show();
                                finish();
                            },Throwable::printStackTrace);
                } else if (btnOk.getText().equals("交班")) {
                    dutyPlanClient.editShiftStatus(trsid, "0")
                            .subscribeOn(Schedulers.io())
                            .observeOn(AndroidSchedulers.mainThread())
                            .subscribe(shiftBean -> {
                                Toast.makeText(this, "等待交班", Toast.LENGTH_SHORT).show();
                                finish();
                            },Throwable::printStackTrace);
                }
                break;
        }
    }
}
